#pragma once

#include <iosfwd>
#include <memory>
#include <string>
#include <functional>
#include <variant>
#include <iostream>

enum class MyError {
    kOk,
    kServerError
};

void testBoolean(bool success) {
    std::cout << success;
}

void testBooleanCallback(std::function<void(bool success)> callback) {
    callback(true);
}

class MyStream {
public:
    int id;
};


void testUniquePtrMyStreamCallback(std::function<void(std::unique_ptr<MyStream> stream)> callback) {
    MyStream stream = MyStream();
    stream.id = 5;
    callback(std::unique_ptr<MyStream>(new MyStream(stream)));
}

void testMyStreamCallback(std::function<void(MyStream stream)> callback) {
    MyStream stream = MyStream();
    stream.id = 5;
    callback(stream);
}
