package com.arrival.mobility.telemetryd.presets;

import org.bytedeco.javacpp.BytePointer;
import org.bytedeco.javacpp.Loader;
import org.bytedeco.javacpp.Pointer;
import org.bytedeco.javacpp.annotation.ByRef;
import org.bytedeco.javacpp.annotation.Cast;
import org.bytedeco.javacpp.annotation.Index;
import org.bytedeco.javacpp.annotation.Name;
import org.bytedeco.javacpp.annotation.Properties;


@Properties(inherit = Telemetryd.class)
@Name("std::string_view") public class StringArray extends Pointer {
    static { Loader.load(); }
    public StringArray(Pointer p) { super(p); }
    public StringArray() { allocate(); }
    private native void allocate();
    public StringArray(StringArray p) { allocate(p); }
    private native void allocate(@ByRef StringArray p);
    public StringArray(BytePointer s, long count) { allocate(s, count); }
    private native void allocate(@Cast("char*") BytePointer s, long count);
    public StringArray(String s) { allocate(s); }
    private native void allocate(String s);
    public native @Name("operator=") @ByRef StringArray put(@ByRef StringArray str);
    public native @Name("operator=") @ByRef StringArray put(String str);
    public native @Name("operator=") @ByRef StringArray put(@Cast("const char*") BytePointer str);
    @Override public StringArray position(long position) {
        return (StringArray)super.position(position);
    }

    public native @Cast("size_t") long size();

    @Index
    public native @Cast("char") int get(@Cast("size_t") long pos);
    public native @Cast("const char*") BytePointer data();

    @Override public String toString() {
        long length = size();
        byte[] bytes = new byte[length < Integer.MAX_VALUE ? (int)length : Integer.MAX_VALUE];
        data().get(bytes);
        return new String(bytes);
    }
}